%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%global svnrev R1177
%global svndate .20090904svn

Name:          canorus
Summary:       Music Score Editor
Version:       0.7
Release:       4.%{svnrev}%{svndate}%{?dist}
Group:         Applications/Editors
# rtmidi is MIT. It gets compiled into the final binary, which is GPLv2
# The rest of the source code, as explicitly indicated by upstream, is GPLv2
# The .can files are Public Domain
License:       GPLv2 and Public Domain
URL:           http://canorus.berlios.de/
# The original source tarball contains content files that have
# unknown and possibly nonfree licenses we remove those bits from the tarball.
# wget http://193.95.242.3/canorusNightly/source/canorus_0.7svn.R1177_source.tar.bz2
# tar jxf canorus_*.tar.bz2
# rm -fr canorus-*/examples/{midi,musicxml}
## This next one is non-commercial use only. So remove...
# rm -fr canorus-*/examples/come_again.can
# tar jcf canorus_0.7svn.R1177_source-FE.tar.bz2 canorus-*
Source0:       canorus_%{version}svn.%{svnrev}_source-FE.tar.bz2
# The following patches are Fedora specific and not sent upstream:
# Remove duplicate copies of docs that are already going to %%doc
Patch0:        %{name}-remove-extra-doc.patch
# Use system fonts instead of bundled ones
Patch1:        %{name}-system-fonts.patch
# Correct python binding installation dir
Patch2:        %{name}-python-dir.patch
# No need to create directories outside the buildroot
Patch3:        %{name}-destdir.patch
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: desktop-file-utils

BuildRequires: alsa-lib-devel
BuildRequires: cmake
BuildRequires: lyx
BuildRequires: qt-devel
BuildRequires: python-devel
BuildRequires: swig
# Ruby scripting not ready yet
#BuildRequires: ruby
#BuildRequires: ruby-devel
BuildRequires: tetex-tex4ht
BuildRequires: zlib-devel

%if 0%{?fedora} >= 11
Requires:      font(centuryschoolbookl)
Requires:      font(emmentaler)
Requires:      font(freesans)
%else
Requires:      freefont
Requires:      lilypond-century-schoolbook-l-fonts
Requires:      lilypond-emmentaler-fonts
%endif
Requires:      hicolor-icon-theme

%description
Canorus is a free extensible music score editor. It supports note writing,
import/export of various file formats, MIDI input and output, scripting and
more! Using a Qt4 framework Canorus offers a fast and modern GUI and
cross-platformability.

%prep
%setup -q -n %{name}-%{version}svn.%{svnrev}
%patch0 -p1 -b .noextradocs
%patch1 -p1 -b .fonts
%patch2 -p1 -b .python
%patch3 -p1 -b .destdir

# Remove bundled copy of zlib
rm -fr src/zlib

# To apply Fedora's optflags properly
sed -i 's|-O0 -g||' src/CMakeLists.txt

# Correct the desktop file
sed -i '/^MimeType.*[^;]$/s/$/;/' %{name}.desktop


%build
%{cmake} -DCANORUS_PYTHON_LIB_DIR="%{python_sitearch}" .

make %{?_smp_mflags}

# Build usersguide
make %{?_smp_mflags} -C doc/usersguide qthelp


%install
rm -rf %{buildroot}

make install DESTDIR=%{buildroot}

# Create the lang file. %%find_lang does not handle .qm files
echo %%dir %{_datadir}/%{name}/lang/ >> %{name}.lang
for file in %{buildroot}%{_datadir}/%{name}/lang/*.qm; do
  language=$(basename $file|cut -f 2 -d _|sed 's|\..*||')
  echo %%lang\($language\) %{_datadir}/%{name}/lang/$language.qm >> %{name}.lang
done

# Handle fonts
rm -f %{buildroot}%{_datadir}/%{name}/fonts/*.ttf
%if 0%{?fedora} >= 11
ln -s ../../fonts/gnu-free/FreeSans.ttf %{buildroot}%{_datadir}/%{name}/fonts/
%else
ln -s ../../fonts/freefont/FreeSans.ttf %{buildroot}%{_datadir}/%{name}/fonts/
%endif
ln -s ../../fonts/lilypond/emmentaler-14.otf %{buildroot}%{_datadir}/%{name}/fonts/
ln -s ../../fonts/lilypond/CenturySchL-Bold.otf %{buildroot}%{_datadir}/%{name}/fonts/
ln -s ../../fonts/lilypond/CenturySchL-BoldItal.otf %{buildroot}%{_datadir}/%{name}/fonts/
ln -s ../../fonts/lilypond/CenturySchL-Ital.otf %{buildroot}%{_datadir}/%{name}/fonts/
ln -s ../../fonts/lilypond/CenturySchL-Roma.otf %{buildroot}%{_datadir}/%{name}/fonts/

# Desktop file
desktop-file-install                           \
   --dir=%{buildroot}%{_datadir}/applications/ \
   --add-category=Midi                         \
   --add-category=X-Notation                   \
   --remove-category=Application               \
   --remove-key=Encoding                       \
   --add-mime-type="application/xml"           \
   %{name}.desktop

# Menu image
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/scalable/apps/
cp -a src/ui/images/general/canorusmlsource.svg \
   %{buildroot}%{_datadir}/icons/hicolor/scalable/apps/%{name}.svg

# Install usersguide
mkdir -p %{buildroot}%{_datadir}/%{name}/doc/usersguide/
cp -a doc/usersguide/*.{qch,qhc} %{buildroot}%{_datadir}/%{name}/doc/usersguide/


%clean
rm -rf %{buildroot}


%post
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database &> /dev/null || :

%postun
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi
update-desktop-database &> /dev/null || :

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%files -f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING DEVELOPERS NEWS README TODO
%doc %{_datadir}/%{name}/doc/
%{_bindir}/%{name}
%{python_sitearch}/*Canorus*
%dir %{_datadir}/%{name}/
%{_datadir}/%{name}/examples/
%{_datadir}/%{name}/fonts/
%{_datadir}/%{name}/images/
%{_datadir}/%{name}/plugins/
%{_datadir}/%{name}/scripts/
%{_datadir}/applications/%{name}.desktop
%{_datadir}/icons/hicolor/scalable/apps/%{name}.svg


%changelog
* Fri Sep 04 2009 Orcan Ogetbil <oget[DOT]fedora[AT]gmail[DOT]com> - 0.7-4.R1177.20090904svn
- SVN revision 1177 (how come is this different from the last snapshot?)
- Fix compilation flags

* Mon Jul 13 2009 Orcan Ogetbil <oget[DOT]fedora[AT]gmail[DOT]com> - 0.7-3.R1177.20090804svn
- SVN revision 1177
- Make package Fedora 10 friendly
- Fix release tag
- Fix license tag
- Add .desktop file categories and mime type
- Remove content with unknown or bad licenses

* Fri Jul 10 2009 Orcan Ogetbil <oget[DOT]fedora[AT]gmail[DOT]com> - 0.7-2.R1163
- Minor cleanup in %%install section

* Thu Jul 09 2009 Orcan Ogetbil <oget[DOT]fedora[AT]gmail[DOT]com> - 0.7-1.R1163
- Initial build
